# Select and export shapefiles by FID and thresholds
import arcpy
import pandas as pd
#define workspace 
df = pd.read_csv(r'E:\temp\NewIdea\paper\Paper\MajorRevisionData\BasinInformation.csv')
Workspace = "E:\\temp\\NewIdea\\paper\\Paper\\MajorRevisionData\\DEM\\DEM_Process\\"
PointSortLoc = Workspace + "PointSort"
OutSelect = Workspace + "Result_Select"
#list feature classes
arcpy.env.workspace = PointSortLoc
fcs = arcpy.ListFeatureClasses()
#query the sorted DEM points using specific criteria
for fc in sorted(fcs, key=lambda x: int(x[1:].split('.')[0])):
    try:
        print("Processing " + str(fc))
        output1 = OutSelect + "\\S" + str(fc)
	#list threshold for each sub-watershed basin
        a = df.iloc[int(fc[1:].split('.')[0])-1]['Threshold']
        print(a)
        print(int(fc[1:].split('.')[0])-1)
        field = arcpy.AddFieldDelimiters(fc, "FID")
        selection = """{field} = {val}""".format(field=field, val=a)
	#loop each row's ID, DEM value
        rows = arcpy.SearchCursor(fc, where_clause=selection, fields="FID; grid_code",sort_fields="grid_code A")
        for row in rows:
            field1 = arcpy.AddFieldDelimiters(fc, "grid_code")
	    #apply selected by attribute
            if row.getValue("grid_code") < 0:
                selection1 = """{field} < {val}""".format(field=field1, val=0)
            else:
                selection1 = """{field} < {val}""".format(field=field1, val=row.getValue("grid_code"))
            arcpy.Select_analysis(fc, output1, selection1)
            print(row.getValue("grid_code"))
            print("S" + str(fc) + " completed")
    except Exception as ex:
        print("S" + str(fc) + " already exists...skipped")

print("Result_Select completed, please run the next file: Result_Raster")